Create Liquidity
This endpoint creates liquidity for a liquidity pool
In: header
Optional provider for entering a liquidity pool. If not provided, Uniswap v3 will be used.
"UNISWAP_V3"The wallet address (in hexadecimal format) that will provide the liquidity.
^0x[a-fA-F0-9]{40}$The address (in hexadecimal format) receiving the token that represents the provided liquidity.
^0x[a-fA-F0-9]{40}$The blockchain network where the liquidity will be provided. Supported EVM chains:
- Arbitrum One: 42161
- Avalanche: 43114
- Base: 8453
- BNB Smart Chain: 56
- Ethereum: 1
- Gnosis: 100
- OP Mainnet: 10
- Polygon: 137
Percentage fee applied to the transaction (e.g., 5 for 5%).
00 <= value <= 99.99The token address (in hexadecimal format) used to pay the transaction fee.
^0x[a-fA-F0-9]{40}$Defines how the fee will be paid: "ADD_TO_AMOUNT" adds it to the input amount, while "DEDUCT_FROM_AMOUNT" subtracts it from the input amount.
"ADD_TO_AMOUNT" | "DEDUCT_FROM_AMOUNT"The address (in hexadecimal format) of the token being swapped from.
^0x[a-fA-F0-9]{40}$The amount of token being swapped from, expressed as a decimal string.
The address (in hexadecimal format) of one of the tokens of the pool.
^0x[a-fA-F0-9]{40}$The address (in hexadecimal format) of the other token of the pool.
^0x[a-fA-F0-9]{40}$Defines the fee earned by providing liquidity. Lower values are recommended for more stable tokens, while higher values are better suited for volatile assets. The values allowed depend on the provider, so check the provider docs too to know which fee tiers are allowed.
0.01 <= value <= 100Minimum price the liquidity will be active. If the price goes below this, the liquidity won't be active and will generate no revenues. This will allow to concentrate the liquidity to a price range, thus enhancing the gains. Price is always p = token1 / token0
0 <= valueMaximum price the liquidity will be active. If the price goes above this, the liquidity won't be active and will generate no revenues. This will allow to concentrate the liquidity to a price range, thus enhancing the gains. Price is always p = token1 / token0
0 <= valueOptional parameter controlling the maximum deviation allowed of the expected price of a trade and the actual price at which the trade is executed, with a minimum value of 0.5 and a maximum value of 99, default is 0.5, where 1 unit equals 1%.
0.50.5 <= value <= 99Optional extra fee that can be charged in addition to the transaction fee (configured in the dashboard or via transactionFeePercent). This extra fee is deducted from the input token and sent to the specified toAddress, allowing you to define a custom recipient for this additional charge.
Empty Object
Response Body
curl -X POST "https://api.notuslabs.xyz/api/v1/liquidity/create" \ -H "Content-Type: application/json" \ -d '{ "walletAddress": "0x6e397ddf51d9f15dbe0414538e7529f51f2e5464", "toAddress": "0x1337133713371337133713371337133713371337", "chainId": 42161, "payGasFeeToken": "0x82af49447d8a07e3bd95bd0d56f35241523fbab1", "gasFeePaymentMethod": "ADD_TO_AMOUNT", "tokenIn": "0x2791bca1f2de4661ed88a30c99a7a9449aa84174", "amountIn": "1.2", "token0": "0x2f2a2543b76a4166549f7aab2e75bef0aefc5b0f", "token1": "0xaf88d065e77c8cc2239327c5edb3a432268e5831", "poolFeePercent": 1, "minPrice": 83475.12, "maxPrice": 102300.5 }'{
"operation": {
"liquidityProvider": "UNISWAP_V3",
"walletAddress": "0x6e397ddf51d9f15dbe0414538e7529f51f2e5464",
"toAddress": "0x1337133713371337133713371337133713371337",
"chainId": 42161,
"transactionFeePercent": 2.5,
"payGasFeeToken": "0x82af49447d8a07e3bd95bd0d56f35241523fbab1",
"gasFeePaymentMethod": "ADD_TO_AMOUNT",
"tokenIn": "0x2791bca1f2de4661ed88a30c99a7a9449aa84174",
"amountIn": "1.2",
"token0": "0x2f2a2543b76a4166549f7aab2e75bef0aefc5b0f",
"token1": "0xaf88d065e77c8cc2239327c5edb3a432268e5831",
"poolFeePercent": 1,
"minPrice": 83475.12,
"maxPrice": 102300.5,
"slippage": 1.2,
"extraFee": {
"percentage": 1.5,
"toAddress": "0x6e397ddf51d9f15dbe0414538e7529f51f2e5464"
},
"metadata": {
"key": "value"
}
}
}{
"statusCode": 400,
"id": "NOT_AUTHORIZED_TOKENS",
"message": ""
}{
"statusCode": 403,
"id": "UNAVAILABLE_COMPUTE_UNITS",
"message": "The project doesn't have enough compute units to perform this action. Please upgrade your plan."
}{
"statusCode": 404,
"id": "ACCOUNT_ABSTRACTION_ADDRESS_NOT_REGISTERED_WITH_PROJECT",
"message": "The requested wallet \"0x6e397ddf51d9f15dbe0414538e7529f51f2e5464\" is not registered with the project"
}Collect fees from liquidity POST
Collects the fees received by the liquidity NFT. This will both create a user operation to be executed and will show how much will be collected, so you can choose if you really want to collect it or not. Always collects the full amount.
Create Swap Liquidity POST
This endpoint creates liquidity for a swap liquidity pool